// MTE MK1 (la Churrera) v5.0
// Copyleft 2010-2014, 2020 by the Mojon Twins

// simple_cocos.h

// A coco is active if its cocos_y has a valid value. Set to >160 to kill coco.
// This is a shortcut as we don't have to check if the coco exits the screen vertically.

// Creation is straightforward: enem N shoots coco N from _en_x+4, _en_y+4, so index with enit.
// Direction is extracted from bits 6, 7 of _en_t and preloaded in rda

void simple_coco_init (void) {
	for (enit = 0; enit < MAX_COCOS_LOOP; ++ enit) cocos_y [enit] = 144;
}

void simple_coco_shoot (void) {
	#asm
			ld  de, (_enit)
			ld  d, 0 					// DE = enit (index)

			ld  hl, _cocos_y
			add hl, de

			ld  a, (hl)
			cp  144
			ret c 						// if cocos_y [enit] < 160: coco is active, ret.

			ld  a, (__en_y)
			add 3
			ld  (hl), a 				// cocos_y [enit] = _en_x + 4

			ld  hl, _cocos_x
			add hl, de
			ld  a, (__en_x)
			add 2
			ld  (hl), a 				// cocos_x [enit] = _en_x + 4

			// ld  a, (_rda)				// direction 

			// ld  e, a
			// ld  d, 0 					// DE = direction
			// ld  hl, __dx
			// add hl, de
			// ld  b, (hl) 				// B = _dx [direction]
			// ld  hl, __dy
			// add hl, de
			// ld  c, (hl) 				// C = _dy [direction]

			// ld  de, (_enit)
			// ld  d, 0 					// DE = enit (index)

			// ld  hl, _cocos_mx
			// add hl, de
			// ld  (hl), b 				// cocos_mx [enit] = B = _dx [direction]

			// ld  hl, _cocos_my
			// add hl, de
			// ld  (hl), c 				// cocos_my [enit] = C = _dy [direction]
	#endasm

	// GW - Balas teledirigidas	
	cocos_gfx [enit] = 0; // grafico por defecto de los cocos
	if (coco_horizontal){
		cocos_my [enit] = 0;
		cocos_mx [enit] = addsign ((gpx-_en_x), 512);
		if (_en_t == 9){
			cocos_gfx [enit] = 1;
			cocos_my [enit] = 512;
			cocos_mx [enit] = 0;
			cocos_y [enit] -= 7;
			cocos_x [enit] += _en_mx;
		}
	}else{
		cocos_mx [enit] =  (gpx - _en_x)<<2;
		cocos_my [enit] =  (gpy - _en_y)<<2;
		if (cocos_mx [enit] < 160 && cocos_my [enit] < 160){
			cocos_mx [enit] =  cocos_mx [enit]<<1;
			cocos_my [enit] =  cocos_my [enit]<<1;
		}
	}

	cocos_gx [enit] = cocos_x [enit] << 6;
	cocos_gy [enit] = cocos_y [enit] << 6;
	AY_PLAY_SOUND (1);
}

void simple_coco_update (void) {
	enspit = SP_COCOS_BASE;
	for (enit = 0; enit < MAX_COCOS_LOOP; ++ enit) {
		
		if (cocos_y [enit] < 144) {
			/*
			#asm				
				._simple_coco_update_do
					// Move coco and copy to simple vars

					ld  de, (_enit)
					ld  d, 0

					ld  hl, _cocos_y 
					add hl, de
					ld  b, (hl) 			// B = cocos_y [enit]

					ld  hl, _cocos_x
					add hl, de
					ld  c, (hl) 			// C = cocos_x [enit]

					ld  hl, _cocos_my
					add hl, de
					ld  a, (hl)
					add b
					ld  (_rdy), a 			// rdy = cocos_y [enit] + cocos_my [enit]

					ld  hl, _cocos_mx
					add hl, de
					ld  a, (hl)
					add c
					ld  (_rdx), a 			// rdx = cocos_x [enit] + cocos_mx [enit]

					// Check if X is off limits
					cp  240
					jr  c, _simple_coco_update_keep_going

					ld  a, 0xff
					ld  (_rdy), a 			// This effectively marks the coco for destruction
					jp  _simple_coco_update_continue

				._simple_coco_update_keep_going
			#endasm
			*/
			
			// GW - Custom cocos
			c_gx = cocos_gx [enit];
			c_gy = cocos_gy [enit];
			
			c_gx = c_gx + cocos_mx [enit];
			c_gy = c_gy + cocos_my [enit];
			
			rdx = c_gx >> 6;
			rdy = c_gy >> 6;
			
			
			
			if (rdx > 240) {
				rdy = 144;
				#asm
					// ld  a, 0xff
					// ld  (_rdy), a 			// This effectively marks the coco for destruction
					jp  _simple_coco_update_continue				
				#endasm
			}
			cocos_gx [enit] = c_gx;
			cocos_gy [enit] = c_gy;
			
			// if (rdy > 150) rdy = 150;
			
			sp_sw [enspit].cx = (rdx + VIEWPORT_X * 8) >> 2;
			sp_sw [enspit].cy = (rdy + VIEWPORT_Y * 8);
			// GW - Si el cocos_gfx NO es 0, se pinta el segundo disparo
			if (!cocos_gfx [enit])	sp_sw [enspit].sp0 = (int) (sprite_19_a); else sp_sw [enspit].sp0 = (int) (sprite_19_a+16);
			
			#asm
				
					// Check collision (player)	
					ld  a, (_dash_time)	// if(dash_time) GW
					or  a 
					jr  nz, _simple_coco_update_continue
					ld  a, (_muriendo)
					or  a 
					jr  nz, _simple_coco_update_continue
				#ifdef PLAYER_FLICKERS
					ld  a, (_p_estado)
					or  a 
					jr  nz, _simple_coco_update_continue
				#endif

					// rdx + 3 >= gpx && rdx + 3 <= gpx + 15 &&
					// rdx + 3 >= gpx && rdx <= gpx + 12

					// rdx + 3 >= gpx
					ld  a, (_gpx)
					ld  c, a
					ld  a, (_rdx)
					add 3
					cp  c 
					jr  c, _simple_coco_update_collpl_done

					// gpx + 12 >= rdx
					ld  a, (_rdx)
					ld  c, a
					ld  a, (_gpx)
					add 12
					cp  c 
					jr  c, _simple_coco_update_collpl_done

					// rdy + 3 >= gpy && rdy + 3 <= gpy + 15
					// rdy + 3 >= gpy && rdy <= gpy + 12

					// rdy + 3 >= gpy
					ld  a, (_gpy)
					ld  c, a
					ld  a, (_rdy)
					add 3
					cp  c 
					jr  c, _simple_coco_update_collpl_done

					// gpy + 12 >= rdy
					ld  a, (_rdy)
					ld  c, a
					ld  a, (_gpy)
					add 12
					cp  c 
					jr  c, _simple_coco_update_collpl_done

					// Kill player
					ld  a, 0xff
					ld  (_rdy), a 			// This effectively marks the coco for destruction

				#ifdef MODE_128K
					ld  a, SFX_ENEMY_HIT
				#else
					ld  a, 48
				#endif
					ld  (_p_killme), a

					jr  _simple_coco_update_continue

				._simple_coco_update_collpl_done

			#endasm
				
			// Check collision (BG)	
			if (attr ((rdx + 3) >> 4, (rdy + 3) >> 4) == 4) rdy = 0xff;

			#asm

				._simple_coco_update_continue
					// And update arrays 
					ld  de, (_enit)
					ld  d, 0

					ld  hl, _cocos_y 
					add hl, de
					ld  a, (_rdy)
					ld  (hl), a

					ld  hl, _cocos_x
					add hl, de
					ld  a, (_rdx)
					ld  (hl), a

				._simple_coco_update_done
			#endasm
		} else {
			
			sp_sw [enspit].cx = (VIEWPORT_X * 8) >> 2;
			sp_sw [enspit].cy = (VIEWPORT_Y * 8);
			sp_sw [enspit].sp0 = (int) (SPRFR_EMPTY);
			
		}
		++ enspit;
	}
}
